public class ExtendedEuklidAlgorithm {
	private int s, t;
	private int q, r, n, m, u1, v1, u2, v2;

	public static void main(String[] args) {
		if(args.length != 2) 
			System.out.println("Bitte zwei ganze Zahlen angeben!");
		new ExtendedEuklidAlgorithm(Integer.parseInt(args[0]), Integer.parseInt(args[1]));
	}

	public ExtendedEuklidAlgorithm(int a, int b) {
		extendedGGT(a, b);
	}

	public void extendedGGT(int a, int b) {
		this.r = 0;
		this.q = 0;
		this.u2 = 0;
		this.v2 = 0;

		this.m = a;
		this.n = b;
		this.s = 1;
		this.t = 0;
		this.u1 = 0;
		this.v1 = 1;

		while(n != 0) {
			System.out.println("m:"+m+" n:"+n);
			q = this.m / this.n;
			r = this.m % this.n;
			this.m = this.n;
			this.n = this.r;
			System.out.println("q=m/n:"+this.q+" r=m%n:"+this.r+" m=n:"+this.m+" n=r:"+this.n);
			this.u2 = this.s - this.q * this.u1;
			this.v2 = this.t - this.q * this.v1;
			System.out.println("s:"+s+" u1:"+this.u1+" u2=s-q*u1:"+this.u2
								+" t:"+t+" v1:"+this.v1+" v2=t-q*v1:"+this.v2);
			this.s = this.u1;
			this.t = this.v1;
			this.u1 = this.u2;
			this.v1 = this.v2;
			System.out.println("s=u1:"+this.s+" t=v1:"+this.t	
								+" u1=u2:"+this.u1+" v1=v2:"+this.v1+"\n");
		}
		System.out.println("GGT: "+m+" = "+s+"*"+a+" + "+t+"*"+b);
	}

// 	public void getMultiplicativeInverse(byte b, byte m) {
// 		this.r = 0;
// 		this.q = 0;
// 		this.u2 = 0;
// 		this.v2 = 0;
// 
// 		this.m = a;
// 		this.n = b;
// 		this.s = 1;
// 		this.t = 0;
// 		this.u1 = 0;
// 		this.v1 = 1;
// 
// 		while(m != 0) {
// 			System.out.println("m:"+m+" n:"+n);
// 			q = this.m / this.n;
// 			r = this.m % this.n;
// 			this.m = this.n;
// 			this.n = this.r;
// 			System.out.println("q=m/n:"+this.q+" r=m%n:"+this.r+" m=n:"+this.m+" n=r:"+this.n);
// 			this.u2 = this.s - this.q * this.u1;
// 			this.v2 = this.t - this.q * this.v1;
// 			System.out.println("s:"+s+" u1:"+this.u1+" u2=s-q*u1:"+this.u2
// 								+" t:"+t+" v1:"+this.v1+" v2=t-q*v1:"+this.v2);
// 			this.s = this.u1;
// 			this.t = this.v1;
// 			this.u1 = this.u2;
// 			this.v1 = this.v2;
// 			System.out.println("s=u1:"+this.s+" t=v1:"+this.t	
// 								+" u1=u2:"+this.u1+" v1=v2:"+this.v1+"\n");
// 		}
// 		System.out.println("GGT: "+m+" = "+s+"*"+a+" + "+t+"*"+b);
// 	}
}
