package AES.graphic;

import java.io.BufferedReader;
import java.io.IOException;

import javax.swing.JTextArea;

public class Console implements Runnable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	JTextArea text_area;
	BufferedReader buf_read;
		
	public Console(JTextArea text_area, BufferedReader buf_read) {
		this.text_area = text_area;
		this.buf_read = buf_read;
	}

	public void run() {
		while(true) {
			try {
				this.text_area.append(buf_read.readLine()+"\n");
				this.text_area.update(this.text_area.getGraphics());
				this.text_area.setCaretPosition(this.text_area.getDocument().getLength());
			}
			catch(IOException e) { e.printStackTrace(); }
		}	
	}
}
